#ifndef CPLD_INTERNAL_H
#define CPLD_INTERNAL_H
#ifdef __KERNEL__

#include <linux/module.h>
#include <linux/seq_file.h>
#include <linux/device.h>

/* internal functions */
int cpld_usr_probe(struct device *dev);
int cpld_usr_remove(struct device *dev);

int cpld_ic_probe(struct device *dev);
int cpld_ic_remove(struct device *dev);

int cpld_irqnotify_probe(struct device *dev);
int cpld_irqnotify_remove(struct device *dev);

int cpld_sfp_probe(struct device *dev);
long cpld_sfp_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
int cpld_sfp_proc_read(struct seq_file *seq, void *v);

int cpld_spi2c_probe(struct device *dev);
int cpld_spi2c_remove(struct device *dev);

#endif
#endif
