#include "ip_secfg_IWF_VTC.h"
#define _IWF_MODULE_NAME "NSN IWF"



extern void iwfD_uplink_hook_register(bool);
bool iwf_sim_flag = false;
bool iwf_ipsec_flag = false;

uint32_t set_test_mode_sim(bool mode)
{
   uint32_t retVal    = VTC_OK;

   iwf_sim_flag = mode;

   /* based on simulation mode handle the uplink hook */
   iwfD_uplink_hook_register(mode);

   return retVal;
}

uint32_t set_ipsec_mode(bool mode)
{
   iwf_ipsec_flag = mode;
   return 0;
}

void ip_se_sicp_teid_api (sIpSicpApiMsg *msg)
{
    sKernelIpCfgMsgHeader* pMsgHeader = getCfgMsgHeader(msg);

    switch (msg->ip_sicp_api.type)
    {
//Uplink functions
        case IP_SETUP_SICP_TEID_SET:
            pMsgHeader->retCode = ip_se_sicp_teid_set(msg);
            break;

        case IP_SETUP_SICP_TEID_GET:
            pMsgHeader->retCode = ip_se_sicp_teid_get(msg);
            break;

        case IP_SETUP_SICP_TEID_DEL:
            pMsgHeader->retCode = ip_se_sicp_teid_del(msg);
            break;

        case IP_SETUP_SICP_TEID_MOD:
            pMsgHeader->retCode = ip_se_sicp_teid_mod_dscp(msg);
            break;
//Downlink functions
        case IP_SETUP_TEID_SICP_MOD:
            pMsgHeader->retCode = ip_se_teid_sicp_mod(msg);
            break;

        case IP_SETUP_TEID_SICP_SET:
            pMsgHeader->retCode = ip_se_teid_sicp_set(msg);
            break;

        case IP_SETUP_TEID_SICP_GET:
            pMsgHeader->retCode = ip_se_teid_sicp_get(msg);
            break;

        case IP_SETUP_TEID_SICP_DEL:
            pMsgHeader->retCode = ip_se_teid_sicp_del(msg);
            break;

        case IP_SETUP_TEID_SICP_CCID_MOD:
            pMsgHeader->retCode = ip_se_teid_sicp_mod_ccid(msg);
            break;

       case IP_SETUP_DL_GTP_MGMT_SET:
            pMsgHeader->retCode = ip_se_gtp_mgmt_error_ind_table_set(msg);
            break;

       case IP_SETUP_DL_GTP_MGMT_GET:
            pMsgHeader->retCode = ip_se_gtp_mgmt_error_ind_table_get(msg);
            break;

       case IP_SETUP_DL_GTP_MGMT_DEL:
            pMsgHeader->retCode = ip_se_gtp_mgmt_error_ind_table_del(msg);
             break;

       case IP_SETUP_DL_GTP_MGMT_MOD:
            pMsgHeader->retCode = ip_se_gtp_mgmt_error_ind_table_mod(msg);
            break;

 #ifdef __PATH_SUPERV_ENABLE__

       case IP_SETUP_CFGTABLE_GTP_MGMT_ENABLE:
            pMsgHeader->retCode = ipcs_gtp_path_mgmt_superv_enable(true);
            break;
       case IP_SETUP_CFGTABLE_GTP_MGMT_DISABLE:
            pMsgHeader->retCode = ipcs_gtp_path_mgmt_superv_enable(false);
            break;
#endif

       case IP_SETUP_CFGTABLE_GTP_MGMT_SET:
            pMsgHeader->retCode = ipcs_set_gtp_mgmt_trswConfigTable(msg);
        break;

       case IP_SETUP_CFGTABLE_GTP_MGMT_MOD:
            pMsgHeader->retCode = ipcs_mod_gtp_mgmt_trswConfigTable(msg);
            break;

       case IP_SETUP_CFGTABLE_GTP_MGMT_GET:
            pMsgHeader->retCode = ipcs_get_gtp_mgmt_trswConfigTable(msg);
            break;

       case IP_SETUP_CFGTABLE_GTP_MGMT_DEL:
            pMsgHeader->retCode = ipcs_del_gtp_mgmt_trswConfigTable(msg);
            break;

      case IP_SETUP_LTE_UP_IP_SET:
            pMsgHeader->retCode = ip_se_lte_ip_set(msg);
            break;

      case IP_SETUP_LTE_UP_IP_GET:
            pMsgHeader->retCode = ip_se_lte_ip_get(msg);
            pMsgHeader->msgFlags |= ICM_RETURN_WITH_DATA;
             break;

      case IP_SETUP_LTE_UP_IP_DEL:
            pMsgHeader->retCode = ip_se_lte_ip_del(msg);
            break;

      /*********MBTAC************/
      case IP_SETUP_LTE_CP_IP_SET:
            pMsgHeader->retCode = ip_se_lte_cp_ip_set(msg);
            break;

      case IP_SETUP_LTE_CP_IP_GET:
            pMsgHeader->retCode = ip_se_lte_cp_ip_get(msg);
            pMsgHeader->msgFlags |= ICM_RETURN_WITH_DATA;
             break;

      case IP_SETUP_LTE_CP_IP_DEL:
            pMsgHeader->retCode = ip_se_lte_cp_ip_del(msg);
            break;

      case IP_SETUP_LTE_SP_IP_SET:
            pMsgHeader->retCode = ip_se_lte_sp_ip_set(msg);
            break;

      case IP_SETUP_LTE_SP_IP_GET:
            pMsgHeader->retCode = ip_se_lte_sp_ip_get(msg);
            pMsgHeader->msgFlags |= ICM_RETURN_WITH_DATA;
             break;

      case IP_SETUP_LTE_SP_IP_DEL:
            pMsgHeader->retCode = ip_se_lte_sp_ip_del(msg);
            break;

        case IP_SETUP_LTE_MBTAC_CONFIG:
            pMsgHeader->retCode = mbtac_ipse_api(msg,pMsgHeader);
            break;

        case IP_SETUP_LTE_IWF_CLEANUP:
            pMsgHeader->retCode = ipcs_lte_iwf_cleanup();
            break;

       case IP_SETUP_LTE_TEST_MODE_SIM:
            pMsgHeader->retCode = set_test_mode_sim(true);
            break;

       case IP_SETUP_LTE_IPSEC_ENABLED:
            pMsgHeader->retCode = set_ipsec_mode(true);
            break;

       case IP_SETUP_LTE_IPSEC_DISABLED:
            pMsgHeader->retCode = set_ipsec_mode(false);
            break;

       case IP_SETUP_LTE_TEST_MODE_NOT_SIM:
            pMsgHeader->retCode = set_test_mode_sim(false);
            break;

       case IP_SETUP_DSCP_PCP_MAP:
            pMsgHeader->retCode = ip_se_lte_DscpToPcp(msg);
            break;

       case IP_SETUP_CPLANE_DSCP_PCP_SET:
            pMsgHeader->retCode = ip_se_lte_CplaneDscpToPcp(msg);
            break;

       case IP_SETUP_MPLANE_DSCP_PCP_SET:
            pMsgHeader->retCode = ip_se_lte_MplaneDscpToPcp(msg);
            break;

       case IP_SETUP_VLANIDS_MAP:
            pMsgHeader->retCode = ip_se_VlanidToGroupIdMap(msg);
            break;

      case IP_SETUP_LTE_VTC_NID_SET:
                printk(KERN_INFO _IWF_MODULE_NAME" msg IP_SETUP_LTE_VTC_NID_SET \n");
            pMsgHeader->retCode = set_vtc_nid(msg);
            break;

       case IP_SETUP_LTE_MP_IP_SET:
            pMsgHeader->retCode = ip_se_lte_mp_ip_set(msg);
            break;

      case IP_SETUP_LTE_MP_IP_GET:
            pMsgHeader->retCode = ip_se_lte_mp_ip_get(msg);
            pMsgHeader->msgFlags |= ICM_RETURN_WITH_DATA;
             break;

      case IP_SETUP_LTE_MP_IP_DEL:
            pMsgHeader->retCode = ip_se_lte_mp_ip_del(msg);
            break;

      case SWITCH_SETUP_L2SWITCH_CONFIG:
            pMsgHeader->retCode = l2switch_cfg_api(msg,pMsgHeader);
            break;

      default:
            printk(KERN_INFO "Kernel Module : msgType not matched Line[%d] \n", __LINE__);
            pMsgHeader->retCode = 0xFFFFFFF;
            break;
    }
}

static sCommonIpCfgMsgHeader* getCommCfgMsgHeader(void *msg) {
    sIwfSetApiMsg* temp = (sIwfSetApiMsg*)msg;
    sCommonIpCfgMsgHeader* pMsgHeader = &(temp->msgHeader);

    return pMsgHeader;
}

static void* getCommCfgMsgPayload (void* msg) {
    sIwfSetApiMsg* iwfSetApiMsg = (sIwfSetApiMsg*)msg;
    void *payload = &(iwfSetApiMsg->iwf_cfg_api);
    return payload;
}

#define DBG_DUMP_ON 0
#if DBG_DUMP_ON
#define DBG_PRT(format, ...) printk(format,##__VA_ARGS__)

#define CPP_DEBUG_TRACE_SIZE 128
#define CPP_DEBUG_BYTES_PER_LINE 40 

static void dump_msg(uint8_t *msgPtr, const uint32_t msgLen, int dir) {
    char str[CPP_DEBUG_TRACE_SIZE];
    char* strPtr;
    uint32_t n;
    char tmpstr[4] ="";
    bool display = false;
    str[0] = '\0';
    strPtr = str;

    for (n = 0; n < msgLen; n++)
    {
        if (msgPtr[n] <= 0xf)
        {
            sprintf(tmpstr, " 0%x", msgPtr[n]);
        }
        else
        {
            sprintf(tmpstr, " %2x", msgPtr[n]);
        }

        strcat(strPtr,tmpstr);
        if ((n % CPP_DEBUG_BYTES_PER_LINE) == 1)
        {
            if (display)
            {
                printk("%s\n",str);
                tmpstr[0] = '\0';
                str[0] = '\0';
                strPtr = str;
            }
            else
            {
                printk("%s Len=%d\n", (dir? "Outgoing" :"Incoming"), msgLen);
                display = true;
            }
        }
    }

    printk("%s\n",str);
}

#define DUMP_MSG(msg, len, direction) dump_msg(msg, len, direction)

void dumpNsnIpAddr(nsn_ip_addr_t *paddr)
{
    printk("Iwf Kernel Module : nsn IpVer[%u] ", paddr->version);
    if(paddr->version == IPv4)
    {
        printk("Ip4[0x%x]\n", paddr->u.ipv4_addr);
    } else {
        printk("Ip6[0x%x 0x%x 0x%x 0x%x]\n", paddr->u.ipv6_addr.__u6_addr.__u6_addr32[0],
            paddr->u.ipv6_addr.__u6_addr.__u6_addr32[1],
            paddr->u.ipv6_addr.__u6_addr.__u6_addr32[2],
            paddr->u.ipv6_addr.__u6_addr.__u6_addr32[3]);
    }
}

void dumpIwfIpAddr(iwf_ip_addr_t *paddr) {
    printk("Iwf Kernel Module : iwf IpVer[%u] ", paddr->version);
    if(paddr->version == IPv4) {
        printk("Ip4[0x%x]\n", paddr->addr_u.ipv4Address.ipa_32);
    } else {
        printk("Ip6[0x%x 0x%x 0x%x 0x%x]\n",
            paddr->addr_u.ipv6Address.ipa_32[0],
            paddr->addr_u.ipv6Address.ipa_32[1],
            paddr->addr_u.ipv6Address.ipa_32[2],
            paddr->addr_u.ipv6Address.ipa_32[3]);
    }
}

#define DUMP_NSN_IP(addr) dumpNsnIpAddr(addr) 
#define DUMP_IWF_IP(addr) dumpIwfIpAddr(addr)
#else
#define DBG_PRT(format, ...)
#define DUMP_MSG(msg, len, direction)
#define DUMP_NSN_IP(addr)
#define DUMP_IWF_IP(addr)
#endif

int fp_app_lte_multi_bearer_iwf_add (void* msg) {
    int rc = 0;
    size_t i;
    uint32_t tmp_retVal  = VTC_OK;
    iwf_set_cfg_api_t *cfg = (iwf_set_cfg_api_t *)getCommCfgMsgPayload(msg);
#if DBG_DUMP_ON 
        printk(KERN_INFO "Iwf Kernel Module : add: type[%u] count[%u]\n", cfg->type, cfg->count);
#endif
    for(i = 0; i < cfg->count; i++) {
        iwf_set_cfg_api_data_t *conf_data   = &cfg->iwf_entry[i];
        uint32_t                ccidUl      = htonl(conf_data->ccidUl);
        uint32_t                pTeid       = htonl(conf_data->peerTeid);
        uint16_t tx_nid =0x123e;
        conf_data->ingress_retval       = VTC_OK;
        conf_data->egress_retval        = VTC_OK;
        conf_data->err_ind_retval       = VTC_OK;

#if DBG_DUMP_ON 
        printk(KERN_INFO "Iwf Kernel Module : add: ccidUl[%u] pteid[%u]\n", ccidUl, pTeid);
#endif
        
        /* DL */
        if(htonl(conf_data->dlKey))
        {
            if((tmp_retVal = set_teid_sicp_connection( htonl(conf_data->dlKey),
                            htons(conf_data->teid_bip_data.eqid.device_id.u16), (tx_nid),
                            htons(conf_data->teid_bip_data.eqid.local_q_id), ccidUl,
                            htons(conf_data->teid_bip_data.msg_type))) != 0)
            {
                conf_data->ingress_retval = tmp_retVal;
                continue;
            }
        }

        /* Err Indication */
        if(pTeid)
        {
            teid_sicp_gtpu_mgmt_data_t teid_sicp_gtpu_mgmt_data;
            memcpy(&teid_sicp_gtpu_mgmt_data.p_ip,&(conf_data->peerIp),sizeof(nsn_ip_addr_t));
            teid_sicp_gtpu_mgmt_data.sicp_data.rx_nid = htons(conf_data->teid_bip_data.eqid.device_id.u16);
            teid_sicp_gtpu_mgmt_data.sicp_data.tx_nid = tx_nid;
            teid_sicp_gtpu_mgmt_data.sicp_data.rx_cpid = htons(conf_data->teid_bip_data.eqid.local_q_id);
            teid_sicp_gtpu_mgmt_data.sicp_data.tx_cpid = ccidUl;
            teid_sicp_gtpu_mgmt_data.sicp_data.mtype = htons(conf_data->teid_bip_data.msg_type);

            // DGB only, check if the two ip adddr format are the same!
            DBG_PRT("set_dl_gtp_mgmt_error_ind_connection: 0x%x\n", pTeid);
            DUMP_NSN_IP(&(conf_data->peerIp));
            DUMP_IWF_IP(&teid_sicp_gtpu_mgmt_data.p_ip);

            tmp_retVal = set_dl_gtp_mgmt_error_ind_connection(pTeid, &teid_sicp_gtpu_mgmt_data);
            if(tmp_retVal != 0)
            {
                conf_data->err_ind_retval = tmp_retVal;
                if(conf_data->dlKey)
                {
                    del_teid_sicp_connection(htonl(conf_data->dlKey)); 
                }
                continue;
            }
        }

        /* UL */
        if(ccidUl)
        {
            sicp_teid_data_t sicp_teid_data;
            memset(&sicp_teid_data, 0, sizeof(sicp_teid_data));
            sicp_teid_data.teid_ul  = htonl(conf_data->peerTeid);
            sicp_teid_data.dscp     = conf_data->dscp;
            //sicp_teid_data.caoptions= conf_data->CaOptions;
            memcpy(&sicp_teid_data.uip_dst, &conf_data->peerIp, sizeof(nsn_ip_addr_t));
            memcpy(&sicp_teid_data.uip_src, &conf_data->eNBIP, sizeof(nsn_ip_addr_t));

            DBG_PRT("Added UL IPs src:dst\n");
            DUMP_IWF_IP(&sicp_teid_data.uip_src);
            DUMP_IWF_IP(&sicp_teid_data.uip_dst);

            if((tmp_retVal = set_sicp_teid_connection(ccidUl, &sicp_teid_data)) != VTC_OK)
            {
                conf_data->egress_retval = tmp_retVal;
                if(conf_data->dlKey)
                {
                    del_teid_sicp_connection(htonl(conf_data->dlKey)); 
                }
                if(pTeid)
                {
                    iwf_ip_addr_t pip; 
                    memcpy(&pip,&(conf_data->peerIp),sizeof(nsn_ip_addr_t));
                    del_dl_gtp_mgmt_error_ind_connection(pTeid, pip);
                }
                continue;
            }
        }
    }
    return rc;
};

int fp_app_lte_multi_bearer_iwf_mod (void* msg) {
    int rc = 0;
    size_t i;
    uint32_t tmp_retVal  = VTC_OK;
    iwf_mod_cfg_api_t *cfg = (iwf_mod_cfg_api_t *)getCommCfgMsgPayload(msg);
#if DBG_DUMP_ON 
        printk(KERN_INFO "Iwf Kernel Module : mod: count[%d]\n", cfg->count);
#endif
    for(i = 0; i < cfg->count; i++) {
        iwf_mod_cfg_api_data_t *conf_data   = &cfg->iwf_entry[i];
        uint32_t                ccidUl      = htonl(conf_data->ccidUl);
        uint32_t                pTeid       = htonl(conf_data->peerTeid);
        uint16_t tx_nid =0x123e;
        conf_data->ingress_retval       = VTC_OK;
        conf_data->egress_retval        = VTC_OK;
        conf_data->err_ind_retval       = VTC_OK;

#if DBG_DUMP_ON 
        printk(KERN_INFO "Iwf Kernel Module : mod: ccidUl[%u] pteid[%u]\n", ccidUl, pTeid);
#endif
        
        /* DL */
        if(htonl(conf_data->dlKey))
        {
            if((tmp_retVal = mod_teid_sicp_connection( htonl(conf_data->dlKey),
                            htons(conf_data->teid_bip_data.eqid.device_id.u16),
                            htons(conf_data->teid_bip_data.eqid.local_q_id))) != 0)
            {
                conf_data->ingress_retval = tmp_retVal;
                continue;
            }
        }

        /* Err Indication */
        if(pTeid && htonl(conf_data->dlKey))
        {
            teid_sicp_gtpu_mgmt_data_t teid_sicp_gtpu_mgmt_data;
            memcpy(&teid_sicp_gtpu_mgmt_data.p_ip,&(conf_data->peerIp),sizeof(nsn_ip_addr_t));
            teid_sicp_gtpu_mgmt_data.sicp_data.rx_nid = htons(conf_data->teid_bip_data.eqid.device_id.u16);
            teid_sicp_gtpu_mgmt_data.sicp_data.tx_nid = tx_nid;
            teid_sicp_gtpu_mgmt_data.sicp_data.rx_cpid = htons(conf_data->teid_bip_data.eqid.local_q_id);
            teid_sicp_gtpu_mgmt_data.sicp_data.tx_cpid = ccidUl;
            teid_sicp_gtpu_mgmt_data.sicp_data.mtype = htons(conf_data->teid_bip_data.msg_type);

            // DGB only, check if the two ip adddr format are the same!
            DUMP_NSN_IP(&(conf_data->peerIp));
            DUMP_IWF_IP(&teid_sicp_gtpu_mgmt_data.p_ip);

            tmp_retVal = mod_dl_gtp_mgmt_error_ind_connection(pTeid, &teid_sicp_gtpu_mgmt_data);
            if(tmp_retVal != 0)
            {
                conf_data->err_ind_retval = tmp_retVal;
                continue;
            }
        }

        /* UL */
        if(ccidUl)
        {
            if((tmp_retVal = mod_sicp_teid_dscp_val(ccidUl, conf_data->dscp)) != VTC_OK)
            {
                conf_data->egress_retval = tmp_retVal;
                continue;
            }
        }
    }
    return rc;
};

int fp_app_lte_multi_bearer_iwf_del (void* msg) {
    int rc = 0;
    size_t i;
    uint32_t tmp_retVal  = VTC_OK;
    iwf_del_cfg_api_t *cfg = (iwf_del_cfg_api_t *)getCommCfgMsgPayload(msg);
#if DBG_DUMP_ON 
        printk(KERN_INFO "Iwf Kernel Module : mod: count[%d]\n", cfg->count);
#endif
    for(i = 0; i < cfg->count; i++) {
        iwf_del_cfg_api_data_t *conf_data   = &cfg->iwf_entry[i];
        uint32_t                ccidUl      = htonl(conf_data->ccidUl);
        uint32_t                pTeid       = htonl(conf_data->peerTeid);
        conf_data->ingress_retval       = VTC_OK;
        conf_data->egress_retval        = VTC_OK;
        conf_data->err_ind_retval       = VTC_OK;

#if DBG_DUMP_ON 
        printk(KERN_INFO "Iwf Kernel Module : del: ccidUl[%u] pteid[%u]\n", ccidUl, pTeid);
#endif
        
        /* DL */
        if(htonl(conf_data->dlKey))
        {
            if((tmp_retVal = del_teid_sicp_connection( htonl(conf_data->dlKey))) != 0)
            {
                conf_data->ingress_retval = tmp_retVal;
                continue;
            }
        }

        /* Err Indication */
        if(pTeid)
        {
            iwf_ip_addr_t pip; 
            memcpy(&pip,&(conf_data->peerIp),sizeof(nsn_ip_addr_t));

            // DGB only, check if the two ip adddr format are the same!
            DUMP_NSN_IP(&(conf_data->peerIp));
            DUMP_IWF_IP(&pip);

            tmp_retVal = del_dl_gtp_mgmt_error_ind_connection(pTeid, pip);
            if(tmp_retVal != 0)
            {
                conf_data->err_ind_retval = tmp_retVal;
                continue;
            }
        }

        /* UL */
        if(ccidUl)
        {
            if((tmp_retVal = del_sicp_teid_connection(ccidUl)) != VTC_OK)
            {
                conf_data->egress_retval = tmp_retVal;
                continue;
            }
        }
    }
    return rc;
};

int processCommHeaderCfgMsg(void *msg) {
    int rc = 0;
    sCommonIpCfgMsgHeader* pMsgHeader = getCommCfgMsgHeader(msg);
    iwf_set_cfg_api_t *cfg = (iwf_set_cfg_api_t *)getCommCfgMsgPayload(msg);
    pMsgHeader->commonNlHeader.nlh.nlmsg_type = NLMSG_DONE;
#if DBG_DUMP_ON 
    printk(KERN_INFO "Iwf Kernel Module : process: msg type[%u] count[%u]\n", cfg->type, cfg->count);
    DUMP_MSG((uint8_t*) msg, pMsgHeader->msgSize, 0);
    printk(KERN_INFO "Iwf Kernel Module : sIwfSetApiMsg size[%d]\n", sizeof(sIwfSetApiMsg));
#endif
    switch (cfg->type)
    {
        case IP_SETUP_LTE_MULTI_BEARER_IWF_ADD:
        {
            rc =  fp_app_lte_multi_bearer_iwf_add(msg);
            break;
        }
        case IP_SETUP_LTE_MULTI_BEARER_IWF_MOD:
        {
            rc =  fp_app_lte_multi_bearer_iwf_mod(msg);
            break;
        }
        case IP_SETUP_LTE_MULTI_BEARER_IWF_DEL:
        {
            rc =  fp_app_lte_multi_bearer_iwf_del(msg);
            break;
        }
	case IP_SETUP_LTE_UP_IP_GET:
	{
            rc = ip_se_lte_ip_get(msg);
            break;
	}
        default:
        {
            rc = -1;
            printk(KERN_INFO "Iwf Kernel Module :cfg msg type not implemented [%d]\n", cfg->type);
            break;
        }
    }
    return rc;
}

uint8_t ip_se_api(void *msg)
{
    uint8_t ret = 0;
    //int replyNeeded = 0;
    sKernelIpCfgMsgHeader* pMsgHeader = getCfgMsgHeader(msg);

    //k2l (TBD: check header size?)
    sCommonIpCfgMsgHeader *pCommHeader = getCommCfgMsgHeader(msg);

    int isSeMagic = 0;
    int isCommMagic = 0;

    if(IP_SE_CFG_MAGIC == pMsgHeader->magic) {
        isSeMagic = 1;
    } else {
        isCommMagic = (IP_SE_COMM_CFG_MAGIC == pCommHeader->magic) ? 1 : 0;
    }

    /* check message format */
    if (IP_SE_CFG_MAGIC != pMsgHeader->magic && IP_SE_COMM_CFG_MAGIC != pCommHeader->magic)
    {
        printk(KERN_INFO "Iwf Kernel Module : magic not match \n");
        goto func_exit;
    }
    //else
    //{
    //    replyNeeded = ((pMsgHeader->msgFlags & (ICM_RETURN_NEEDED | ICM_RETURN_WITH_DATA)) != 0);
    //}

#if DBG_DUMP_ON 
    printk(KERN_INFO "Iwf Kernel Module : match seMsg[%d] commMsg[%d] \n", isSeMagic, isCommMagic);
#endif

    if(isSeMagic) {
        /* assume everything works ok */
        pMsgHeader->retCode = 0;
        /* Some of the config functions still check msg->l4_prot */
        switch (pMsgHeader->msgType)
        {
        case SE_DRV_CFG_TEID_SICP:
            ip_se_sicp_teid_api(msg);
            break;

        default:
            pMsgHeader->retCode = 0xFFFFFFFF;
            break;
        }
    } else {
        pCommHeader->retCode = 0;
        processCommHeaderCfgMsg(msg);
    }

func_exit:
#if 0
    /* common exit */
    if (replyNeeded)
    {
        //reply to be sent;
    }
    else
    {
        //msg to be discarded
        //nsn_discard_msg(msg);
    }
#endif
    return ret;

}



int main(int argc, char *argv[])
{

      mbTacInit();
      return 0;
}


